signature TEST = 
sig
  
 val testAll : unit -> unit

end; (* signature Test *)

functor Test (structure PropProver : PROPPROVER) :> TEST = 
struct

  local 
    structure F = PropProver
    open P  

    val A = P.Atom("A");
    val B = P.Atom("B");
    val C = P.Atom("C");
    val D = P.Atom("D");
      
  in
    
    exception Done of int 

    fun entails (A1, A2) = 
      F.prove (C.Decl (C.Null, ("u", A1)), A2) 

    fun prove (A) = F.prove (C.Null, A)  

    fun prove A = F.prove (C.Null, A)

  (* From Exercise 2.8 *)

    val A1a = Implies (A, Implies (B, C))
    val A1b = Implies (And (A, B), C)
    val A2a = Implies (A, And (B, C))
    val A2b = And (Implies (A, B), Implies (A, C))
    val A3a = Implies (A, Or (B, C))
    val A3b = Or (Implies (A, B), Implies (A, C))
    val A4a = Implies (Implies (A, B), C)
    val A4b = And (Or (A, C), Implies (B, C))
    val A5a = Implies (Or (A, B), C)
    val A5b = And (Implies (A, C), Implies (B, C))
    val A6a = And (A, Or (B, C))
    val A6b = Or (And (A, B), And (A, C))
    val A7a = Or (A, And (B, C))
    val A7b = And (Or (A, B), Or (A, C))

  fun testAll () = 
  ( entails (A1a, A1b);
    entails (A1b, A1a);
    entails (A2a, A2b);
    entails (A2b, A2a);
    entails (A3a, A3b);
    entails (A3b, A3a);
    entails (A4a, A4b);
    entails (A4b, A4a);
    entails (A5a, A5b);
    entails (A5b, A5a);
    entails (A6a, A6b);
    entails (A6b, A6a);
    entails (A7a, A7b);
    entails (A7b, A7a))
  end

 val testAll = testAll

end;

structure Test = Test (structure PropProver = PropProver)